<template>
  <single-pane :capt="dictionaryRu.title">
    <div class="location-types">
      <ob-tabs
        v-model="currentTab"
        :items="locationTypesButtons"
        @on-change-tab="onChangeTabHandler"
        value-exp="uuid"
      />
    </div>
    <ob-table
      :columns="columnsObTable"
      :functional-panel="true"
      show-add-button
      :remote-opt="{
        method: getObTableData,
        arguments: {
          filters
        }
      }"
      is-fixed-header
      @select="onSelectionLocation"
      @add="onAdd"
      ref="obTable"
    />
    <ob-modal
      ref="viewItem"
      :title="newStatus ? dictionaryRu.modal.add_title : selectedData.russian_name"
      :titleSecond="newStatus ? dictionaryRu.MODAL.titleSecond.add : dictionaryRu.MODAL.titleSecond.view"
      :is-show-pagination="!newStatus"
      size="xl"
    >
      <location
        :locationTypes="locationTypes"
        :data-source="Object.keys(selectedData).length > 0 ? selectedData : defaultLocation"
        :user-access="userAccess"
        :api="api"
        :activeRailStations="activeRailStations"
        @history="onHistory"
        @delete="preparedDelete"
        @submit="preparedSave"
        @refresh="onRefresh"
      />
    </ob-modal>
    <ob-modal
      ref="historyItem"
      :title="dictionaryRu.modal.change_history"
      :edit-form="false"
      custom-class="modal-large"
    >
      <history-modal
        v-if="selectedData.uuid"
        type="locations"
        :uuid="selectedData.uuid"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import api                   from '@/api';
import { getIconByLocation } from '@/helpers';
import paging                from '@/mixins/dictionaries/paging';
import itemMixin             from '@/mixins/dictionaries/edit-item';
import userAccessMixin       from '@/mixins/user-access-mixin';
import Location              from './modal/Location';
import HistoryModal          from './modal/HistoryModal';
import SinglePane            from 'common-components/src/obComponents/obSinglePanels';
import ObModal               from 'common-components/src/obComponents/obModal';
import ObTabs                from 'common-components/src/obComponents/obTabs';
import ObTable               from 'common-components/src/obComponents/obTable';
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary }        from '@/translations/ru/dictionaries__locations__locations_list';

export default {
  name: 'Locations',
  components: {
    ObModal,
    ObTable,
    SinglePane,
    HistoryModal,
    Location,
    ObTabs
  },
  mixins: [
    paging,
    itemMixin,
    userAccessMixin
  ],
  async beforeMount() {
    await this.loadLocationTypesAndCounts();
  },
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.russian_name,
          key: 'russian_name',
          html: function(data) {
            return data.russian_name ? data.russian_name : data.russian_address;
          }
        },
        {
          title: "Страна",
          key: 'short_title',
          html: function(data) {
            return data.short_title || "—"
          }
        },
        {
          title: this.dictionaryRu.columns.location_type,
          key: 'location_type_uuid',
          width: 150,
          html: data => {
            if (data.location_type_uuid) {
              const _type = this.locationTypes.find(type => {
                return type.uuid === data.location_type_uuid;
              });
              return _type
                ? _type.name
                : '';
            }
            return '';
          }
        },
        {
          title: this.dictionaryRu.columns.english_name,
          key: 'english_name'
        },
        {
          title: this.dictionaryRu.columns.local_name,
          key: 'local_name'
        },
        {
          title: this.dictionaryRu.columns.zero_interrogation_radius,
          width: 110,
          key: 'location_radius.zero_interrogation_radius',
          html: function(data) {
            if (
              data.location_radius &&
              data.location_radius.zero_interrogation_radius
            ) {
              return String(data.location_radius.zero_interrogation_radius);
            }
            return '-';
          }
        },
        {
          title: this.dictionaryRu.columns.vehicle_arrival_radius,
          width: 110,
          key: 'location_radius.vehicle_arrival_radius',
          html: function(data) {
            if (
              data.location_radius &&
              data.location_radius.vehicle_arrival_radius
            ) {
              return String(data.location_radius.vehicle_arrival_radius);
            }
            return '-';
          }
        },
        {
          title: this.dictionaryRu.columns.vehicle_departure_radius,
          width: 110,
          key: 'location_radius.vehicle_departure_radius',
          html: function(data) {
            if (
              data.location_radius &&
              data.location_radius.vehicle_departure_radius
            ) {
              return String(data.location_radius.vehicle_departure_radius);
            }
            return '-';
          }
        },
        ...(this.currentTab.code === 'REFERENCE_POSITION' ? [{
          title: this.dictionaryRu.columns.stations,
          width: 110,
          key: 'rail_stations_count',
          html: data => {
            return data.rail_stations_count ? data.rail_stations_count : '—'
          }
        }] : []),
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'is_active',
          html: data => {
            return !data.is_active
              ? this.dictionaryRu.status.inactive
              : this.dictionaryRu.status.active;
          }
        }
      ];
    }
  },
  data() {
    return {
      activeRailStations: [],
      dictionaryRu: Object.assign(dictionary, dictionaryDefault),
      locationTypes: [],
      showAddButton: false,
      api: {
        source: '/oboz2-dictionary-locations-crud/v1/'
      },
      userAccessMap: {
        CRUD: ['dictionary__locations__list_read'],
        CREATE: ['dictionary__locations__details_create'],
        VIEW: ['dictionary__locations__details_read'],
        UPDATE: ['dictionary__locations__details_update'],
        DELETE: ['dictionary__locations__details_delete']
      },
      remoteOperations: {
        paging: true,
        sorting: true
      },
      locationTypesButtons: [],
      currentTab: {
        data_completion: undefined,
        icon: undefined,
        title: dictionary.all,
        tooltip: false,
        uuid: null,
      },
      defaultLocation: {
        coordinates: {
          lat: '',
          lon: ''
        },
        country_symbol_code: "",
        english_address: "",
        english_name: "",
        is_active: true,
        local_address: "",
        local_name: "",
        location_info: null,
        location_radius: {
          hard_binding_radius: 0,
          vehicle_arrival_radius: 0,
          vehicle_departure_radius: 0,
          zero_interrogation_radius: 0
        },
        location_type_uuid: "",
        russian_address: "",
        russian_name: "",
        short_ttitle: "",
        title: "",
        uuid: "",
        railway_terminal_uuid: "",
        container_terminal_uuid: ""
      }
    };
  },
  methods: {
   async  loadLocationTypesAndCounts() {
      try {
        let allTypes = await api.locations.getLocationTypes(false, 0, 100);
        if (!allTypes || allTypes.error) throw new Error('Ошибка загрузки типов локаций')
        let typesCount = await api.locations.getLocationTypesCount();
        if (!typesCount || typesCount.error) throw new Error('Ошибка загрузки данных по локациям')

        let totalCount = 0;
        allTypes = allTypes.data.content.map(type => {
          let associate = typesCount.find(
              item => item.location_uuid === type.uuid
          );
          let count = associate ? associate.count : 0;
          totalCount += count;

          return { ...type, count, icon: this.getIconByLocation(type.uuid) };
        });

        this.locationTypes = allTypes;

        this.locationTypesButtons = [
          {
            name: this.dictionaryRu.all,
            count: totalCount,
            uuid: null
          }
        ]
            .concat(allTypes)
            .map(item => {
              let { name, uuid, code, count } = item;
              let tooltip = uuid
                  ? {
                    content: name,
                    openDelay: 500
                  }
                  : false;

              return {
                title: uuid ? `${count}` : name,
                uuid,
                code,
                tooltip,
                data_completion: item.data_completion,
                icon: this.getIconByLocation(uuid)
              };
            });
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },

    isRefPosition(locationTypeUuid) {
      if (!locationTypeUuid) return
      const _type = this.locationTypes.find(type => {
        return type.uuid === locationTypeUuid;
      });
      return _type.code && _type.code === 'REFERENCE_POSITION'
    },
    setFilter(key, value) {
      this.filters[key] = value;
      let type = this.locationTypesButtons.find(i => i.code === value);
      this.showAddButton = type.data_completion == 'Вручную';
      this.$refs.obTable.loadData({ init: true });
    },
    onChangeTabHandler(data) {
      this.setFilter('location_type_code', data.code);
    },
    async onSelectionLocation(data) {
      let _data = await this.eiGet(data);
      this.newStatus = false;
      this.selectedData = _data.data;

      if (!this.selectedData.location_radius) {
        this.selectedData.location_radius = {};
      }

      [
        'zero_interrogation_radius',
        'vehicle_arrival_radius',
        'vehicle_departure_radius'
      ].forEach(value => {
        if (!this.selectedData.location_radius[value]) {
          this.$set(this.selectedData.location_radius, value, 0);
        }
      });
      if (this.selectedData.rail_stations.length) {
        this.activeRailStations = [...this.selectedData.rail_stations];
        this.selectedData.rail_stations = this.selectedData.rail_stations.map(item => item.uuid);
      }
      this.$refs.viewItem.open();
    },
    preparedSave(payload) {
      this.onSave(payload);
      this.loadLocationTypesAndCounts();
    },
    preparedDelete() {
      this.onDelete();
      this.loadLocationTypesAndCounts();
    },
    getIconByLocation
  }
};
</script>

<style scoped lang="scss">
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";
.view-center-map {
  width: 20px;
  height: 24px;
  display: block;
  border: 0;
  box-shadow: none;
  position: absolute;
  bottom: 16px;
  right: 10px;
}

.location-types {
  &__title {
    color: $color-blue-navy-blue;
    line-height: 1.2;
    margin-right: 8px;
  }

  &__count {
    color: $locationsPage-location_types_count;
    font-weight: 200;
    line-height: 1.2;
  }

  &__img {
    display: flex;
    justify-content: flex-start;
    align-items: center;
    margin-right: 8px;
    font-size: 25px;
  }

  &__button-content {
    display: flex;
    justify-content: flex-start;
    align-items: center;
  }

  padding: 20px;

  .el-button {
    border-radius: 3px !important;
    background: white;
    border: 0;
    line-height: inherit;

    &:first-child {
      .location-types__title {
        display: block !important;
      }
    }
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue, 0.4px);
    &.active {
      background: $color-blue-navy-blue;
      color: white;

      .location-types__title {
        color: $locationsPage-location_types_el_active_title;
      }

      .location-types__count {
        color: $locationsPage-location_types_el_active_count;
      }

      img {
        filter: grayscale(100%) invert(200%);
      }
    }
  }
}
</style>
<style lang="scss">
.location-types {
  .icon {
    &.container {
      width: auto;
    }
  }
}
</style>
